<?xml version="1.0" encoding="UTF-8"?>
<!--
 *   
 * This is a common dao with basic CRUD operations and is not limited to any 
 * persistent layer implementation
 * 
 * Copyright (C) 2008  Imran M Yousuf (imyousuf@smartitengineering.com)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <parent>
    <groupId>com.smartitengineering</groupId>
    <artifactId>smart-core</artifactId>
    <version>0.1-SNAPSHOT</version>
  </parent>
  <groupId>com.smartitengineering</groupId>
  <artifactId>smart-dao</artifactId>
  <packaging>pom</packaging>
  <version>0.4-SNAPSHOT</version>
  <name>Smart DAO</name>
  <inceptionYear>2007</inceptionYear>
  <description>
    This project basically aims to create an abstraction layer above common
    ORM used this days and provide a simplified DAO layer which is not only
    independent of the ORM tool being used but also integrated with other
    services, for example App Layer Caching, Free Text Search Engine etc.
    Initial target is to implement it for Hibernate and when JPA provides
    Hibernate's Criteria like API implement for JPA as well. Integrate
    App Layer Cache and Compass Framework.
  </description>
  <url>http://code.google.com/p/smart-dao</url>
  <issueManagement>
    <system>Google Code Issue Tracker</system>
    <url>http://code.google.com/p/smart-dao/issues/</url>
  </issueManagement>
  <mailingLists>
    <mailingList>
      <name>User List</name>
      <archive>http://groups.google.com/group/smart-dao-users</archive>
      <post>smart-dao-users@googlegroups.com</post>
      <subscribe>smart-dao-users-subscribe@googlegroups.com</subscribe>
      <unsubscribe>smart-dao-users+unsubscribe@googlegroups.com</unsubscribe>
    </mailingList>
    <mailingList>
      <name>Developer List</name>
      <archive>http://groups.google.com/group/smart-dao-dev</archive>
      <post>smart-dao-dev@googlegroups.com</post>
      <subscribe>smart-dao-dev-subscribe@googlegroups.com</subscribe>
      <unsubscribe>smart-dao-dev+unsubscribe@googlegroups.com</unsubscribe>
    </mailingList>
  </mailingLists>
  <licenses>
    <license>
      <name>LGPL v3</name>
      <distribution>repo and manual</distribution>
      <url>http://www.gnu.org/licenses/lgpl.html</url>
    </license>
  </licenses>
  <developers>
    <developer>
      <id>imyousuf</id>
      <name>Imran M Yousuf</name>
      <email>imyousuf@smartitengineering.com</email>
      <organization>Smart IT Engineering</organization>
      <timezone>GMT +0600</timezone>
      <roles>
        <role>Project Owner</role>
        <role>Developer</role>
        <role>Maintainer</role>
      </roles>
    </developer>
  </developers>
  <scm>
    <connection>scm:git:git://github.com/imyousuf/smart-dao.git</connection>
    <developerConnection>scm:git:ssh://git@github.com:imyousuf/smart-dao.git</developerConnection>
  </scm>
  <distributionManagement>
    <site>
      <id>smartit-googlecode</id>
      <name>Smart IT Engineering GoogleCode repository</name>
      <url>svn:https://imyousuf@smart-it.googlecode.com/svn/maven2/site/dao</url>
    </site>
  </distributionManagement>
  <build>
    <plugins>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-source-plugin</artifactId>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-javadoc-plugin</artifactId>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-compiler-plugin</artifactId>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-surefire-plugin</artifactId>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-release-plugin</artifactId>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-scm-plugin</artifactId>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-changelog-plugin</artifactId>
        <inherited>false</inherited>
        <dependencies>
          <dependency>
            <groupId>org.codehaus.plexus</groupId>
            <artifactId>plexus-utils</artifactId>
            <version>${plexus-utils.version}</version>
          </dependency>
          <dependency>
            <groupId>org.apache.maven.scm</groupId>
            <artifactId>maven-scm-provider-gitexe</artifactId>
            <version>${scm.version}</version>
          </dependency>
        </dependencies>
      </plugin>
    </plugins>
  </build>
  <reporting>
    <plugins>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-site-plugin</artifactId>
        <inherited>true</inherited>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-javadoc-plugin</artifactId>
        <configuration>
          <aggregate>false</aggregate>
          <linksource>true</linksource>
        </configuration>
      </plugin>
      <plugin>
        <groupId>org.codehaus.mojo</groupId>
        <artifactId>cobertura-maven-plugin</artifactId>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-surefire-report-plugin</artifactId>
        <inherited>true</inherited>
      </plugin>
      <plugin>
        <groupId>org.codehaus.mojo</groupId>
        <artifactId>findbugs-maven-plugin</artifactId>
        <inherited>true</inherited>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-changelog-plugin</artifactId>
        <configuration>
          <type>tag</type>
          <tags>
            <tag implementation="java.lang.String">${last.release.tag}
            </tag>
            <tag implementation="java.lang.String">HEAD
            </tag>
          </tags>
        </configuration>
      </plugin>
    </plugins>
  </reporting>
  <profiles>
    <profile>
      <id>build-ext</id>
      <activation>
        <property>
          <name>build.complete</name>
          <value>true</value>
        </property>
      </activation>
      <build>
        <plugins>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-changelog-plugin</artifactId>
            <inherited>false</inherited>
            <dependencies>
              <dependency>
                <groupId>org.codehaus.plexus</groupId>
                <artifactId>plexus-utils</artifactId>
                <version>${plexus-utils.version}</version>
              </dependency>
              <dependency>
                <groupId>org.apache.maven.scm</groupId>
                <artifactId>maven-scm-provider-gitexe</artifactId>
                <version>${scm.version}</version>
              </dependency>
            </dependencies>
            <configuration>
              <outputXML>./target/change/changes.xml</outputXML>
            </configuration>
            <executions>
              <execution>
                <id>attach-changelog</id>
                <phase>generate-sources</phase>
                <inherited>false</inherited>
                <goals>
                  <goal>changelog</goal>
                </goals>
              </execution>
            </executions>
          </plugin>
          <plugin>
            <groupId>org.codehaus.mojo</groupId>
            <artifactId>xml-maven-plugin</artifactId>
            <inherited>false</inherited>
            <executions>
              <execution>
                <id>generate-changes</id>
                <phase>generate-resources</phase>
                <inherited>false</inherited>
                <goals>
                  <goal>transform</goal>
                </goals>
              </execution>
            </executions>
            <configuration>
              <transformationSets>
                <transformationSet>
                  <dir>./target/change</dir>
                  <stylesheet>src/main/xsl/changes.xsl</stylesheet>
                </transformationSet>
              </transformationSets>
            </configuration>
          </plugin>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-antrun-plugin</artifactId>
            <inherited>false</inherited>
            <executions>
              <execution>
                <id>rename-changes</id>
                <phase>generate-resources</phase>
                <inherited>false</inherited>
                <goals>
                  <goal>run</goal>
                </goals>
                <configuration>
                  <tasks>
                    <move file="target/generated-resources/xml/xslt/changes.xml" tofile="target/generated-resources/xml/xslt/changes-${version}.html" verbose="true"/>
                  </tasks>
                </configuration>
              </execution>
            </executions>
            <dependencies>
              <dependency>
                <groupId>ant-contrib</groupId>
                <artifactId>ant-contrib</artifactId>
                <version>${ant-contrib.version}</version>
              </dependency>
            </dependencies>
          </plugin>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-assembly-plugin</artifactId>
            <inherited>true</inherited>
            <executions>
              <!-- Assembly execution for aggregating gh-pages -->
              <execution>
                <id>assemble-static-gh-pages</id>
                <phase>compile</phase>
                <inherited>false</inherited>
                <goals>
                  <goal>single</goal>
                </goals>
                <configuration>
                  <descriptors>
                    <descriptor>src/main/assembly/assemble-gh-pages.xml</descriptor>
                  </descriptors>
                </configuration>
              </execution>
              <!-- Filter README -->
              <execution>
                <id>assemble-readme</id>
                <phase>compile</phase>
                <inherited>true</inherited>
                <goals>
                  <goal>single</goal>
                </goals>
                <configuration>
                  <descriptors>
                    <descriptor>src/main/assembly/assemble-readme.xml</descriptor>
                  </descriptors>
                </configuration>
              </execution>
            </executions>
          </plugin>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-site-plugin</artifactId>
            <inherited>true</inherited>
            <executions>
              <execution>
                <id>site-gen</id>
                <phase>prepare-package</phase>
                <inherited>true</inherited>
                <goals>
                  <goal>site</goal>
                </goals>
              </execution>
            </executions>
          </plugin>
        </plugins>
      </build>
    </profile>
    <profile>
      <id>sonar-config</id>
      <activation>
        <property>
          <name>sonar.enabled</name>
          <value>true</value>
        </property>
      </activation>
      <build>
        <plugins>
          <plugin>
            <groupId>org.codehaus.mojo</groupId>
            <artifactId>sonar-maven-plugin</artifactId>
          </plugin>
        </plugins>
      </build>
    </profile>
  </profiles>
  <modules>
    <module>smart-hibernate-abstract-dao</module>
    <module>smart-abstract-dao</module>
    <module>smart-domain</module>
    <module>smart-cache</module>
    <module>smart-dao-search</module>
    <module>smart-version</module>
    <module>smart-dao-queryparam</module>
    <module>smart-rs</module>
    <module>docs</module>
    <module>smart-exim</module>
    <module>smart-hbase-dao</module>
  </modules>
</project>
